#!/usr1/local/bin/perl5 -T
# $Id: biblink.pl,v 1.2 2002/10/21 15:24:45 cwh Exp $

# This program extracts data product URLs from the HEASARC
# database and displays them to the requester.  This user
# must specify the table for which the data products
# are desired and values of key parameters.  The
# user may specify which data product types are desired and
# the format of the output.  Optionally the user can
# request information about just the available datasets
# and the key values.
#
# Usage:
#    getProd may be called using either a GET or POST URL
#    The HTTP keyword arguments are:
#
#    -source=		The table for which data products are requested.
#    -meta.all          Show available tables.
#    -product=		A specifically requested data product.
#    'field1' ... 	where 'field1', 'field2' are the names
#                       of the query keys for the desired table.
# Written January 29, 2001, By T. McGlynn, NASA/GSFC (USRA).

use strict;
use lib "./lib";

use Browse::Config;
Browse::Config::AlwaysRun();

my $header;

# Get arguments.
my $in = Browse::CGI::ReadParse();

Browse::DBQ::Registry::init("./databases.dat");

my $bibcode = $$in{'code'};
my $query = "select * from zzbib where bibcode = '$bibcode' order by table_name";

my ($results, $names) = Browse::DBQ::query($query);
if ($#$results < 0) {
    noresults($$in{code});
}

$query = "files=Preview&Coordinates=Equatorial&Equinox=2000&CheckSize=1&showgifs=1";

my $result;
foreach $result(@$results) {
    $query .= "&Target=$$result[1]|||$$result[2]=$$result[3]||";
}

my $source;
if ($$in{source}) {
    $source = $$in{source};
} else {
    $source = "BibCode query: ".$$in{code};
}

$source = "<span class=navpast> $source </span>";
$query .= "&navtrail=".Browse::CGI::Encode($source);

print "Location: /$::cgi/w3hdprods.pl?$query\n\n";
exit;

sub noresults() {
    print "Content-type: text/html\n\nNo indexed HEASARC observations for bibcode $_[0]\n";
    exit();
}
