#!/usr1/local/bin/perl5 -wT

use strict;
use lib './lib';
use IO::Socket;
use CGI;
use Browse::Decor;

# variables
my $heraserver = 'herasrv.gsfc.nasa.gov'; # heraserver machine
      my $port = 9468; # port on heraserver
        my $id = 'HeraBrowser'; # string that identifies me to the Hera manager

  my $key = rand(); # session key

  my $query = new CGI;
$query->dump;
  $query->import_names('H');

  #Browse::Decor::Header("Save Files to Hera",1,0);
   
  my($stylecolor) = "heratable";
  Browse::Decor::Header("Save Files to Hera",1,0,0,$stylecolor);

# Check that we have what we need.
# We expect $H::controlid, $H::password, 
# $H::newuser (1 or 0), and $H::filelist (comma-sep list of filenames)
  quit("Please enter a username.") unless $H::controlid =~ /\w/;
  quit("Please enter your password. (For new users, enter desired password.)") 
      unless $H::password =~ /\w/;
  quit("Please select new or existing user.") unless $H::newuser =~ /\d/;
  quit("No FITS files found to save.  Please go back and reselect.") unless 
      $H::filelist =~ /\w/;


# Get socket connection
  my $heramgr = new IO::Socket::INET (PeerAddr => $heraserver,
                                     PeerPort => $port,
                                     Proto    => 'tcp');

  quit("Unable to contact Hera manager.  Reason: $!") unless $heramgr;
print "got socket connection to $heraserver\n";


# Establish Trust Channel
  print $heramgr "EstablishTrustChannel $id $key\n";
  my $ans = <$heramgr>;
  quit("Can't establish trusted channel with Hera manager: $ans") 
    unless $ans =~ /AGREED/;
print "got trusted channel\n";

# Authentication
  print $heramgr "Authentication $id $key $H::controlid $H::password\n";
  $ans = <$heramgr>;
  quit("Can't authenticate $H::controlid: $ans") 
    unless $ans =~ /NEW_RECONFIRM|PASS/;
print "authenticated\n";

# Create User Space if new user
  if ($ans =~ /NEW_RECONFIRM/ and !$H::newuser) {
    # user name not found, but user said they were not new
    quit("User $H::controlid is not an existing user.  Please check that the name is entered correctly.");
  } elsif ($ans !~ /NEW_RECONFIRM/ and $H::newuser) {
    # user name found, but user said they were new
    quit("Username $H::controlid is already taken.  Please try another username.");
  } elsif ($ans =~ /NEW_RECONFIRM/ and $H::newuser) {
    # user name not found, and user said they were new - create user space
    print $heramgr "CreateUserSpace $id $key $H::controlid\n";
    $ans = <$heramgr>;
    quit("Unable to create user space: $ans") unless $ans =~ /DONE/;
print "created new user space\n";
  }



# Make Links
  my $count=0;
  foreach my $file (split',',$H::filelist) {
     print $heramgr "MakeLink $id $key $H::controlid $file\n";
     $ans = <$heramgr>;
     print "Unable to create link to file $file: $ans" unless $ans =~ /DONE/;
     $count++ if $ans =~ /DONE/;
print "Created link to file $file: $ans" if $ans =~ /DONE/;
  }
print "done creating links\n";


# Close Trusted Channel
  print $heramgr "CloseTrustedChannel $id $key\n";
  close($heramgr); 
print "Closed trusted channel\n";

  if ($count) {
    quit("Successful. Saved $count files to $H::controlid\'s Hera space.\n");
  } else {
    quit("No files saved.\n");
  }

sub quit {
   print "@_ </body></html>\n";
print "quit\n";
   exit;
}
