#$Id: BatFOV.pm,v 1.1 2005/04/05 13:11:48 lmm Exp $
#----------------------------------------------------------------------------
#--- Convert coordinates and create Bat FOV query
#--- Addapted from code supplied by Tom McGlynn
#----------------------------------------------------------------------------
use strict;
package Browse::BatFOV;

use lib "/www/server/vo/inst/local/lib";

use VO::Service;
use WEB;

use lib "/www/htdocs/cgi-bin/W3Browse/lib";

use Browse::DBQ;

#--- Create SQL for BATFOV search
sub createSQL {

  my $position = $_[0];
  my $coordsys = $_[1];
  print "pos=$position <br>" if $::debug;
  my ($ura, $udec) = getPosition($position,$coordsys);
  
  my $d = 4*atan2(1,1)/180;
  
  
  my $cdb = "cos(-$d*dec)";
  my $sdb = "sin(-$d*dec)";
  my $cab = "cos($d*ra)";
  my $sab = "sin($d*ra)";
  
  my $crb = "cos(-$d*roll_angle)";
  my $srb = "sin(-$d*roll_angle)";
  
  my $ux = cos($d*$ura)*cos($d*$udec);
  my $uy = sin($d*$ura)*cos($d*$udec);
  my $uz = sin($d*$udec);
  
  my $x = "($ux) * $cdb*$cab + ($uy) * $cdb*$sab - ($uz) * $sdb";
  my $y = "($ux) * ($srb*$sdb*$cab-$crb*$sab) + ($uy) * ($srb*$sdb*$sab+$crb*$cab) + ($uz) * $cdb*$srb";
  my $z = "($ux) * ($crb*$sdb*$cab+$srb*$sab) + ($uy) * ($crb*$sdb*$sab-$srb*$cab) + ($uz) * $cdb*$crb";
  
  
  my $axis1 = 1.7;
  my $axis2 = 0.9;
  if (defined($_[2])) {
       $axis1 = $_[2];
  }   
  if (defined($_[3])) {
       $axis2 = $_[3];
  }   
  my $whereSql = " ($x > 0)  AND ( power(($y)/($x)/$axis1,2) + power(($z)/($x)/$axis2, 2) < 1)";
  
  
  my $sql = "select obsid,target_id,ra,dec from heasarc_swiftmastr where (bat_expo_sv > 0) and $whereSql";
  
  return " > 0 and $whereSql";
}
  
#--- Query VO service to convert object name to coordinates
sub getPosition {

    my ($pos,$coordsys) = @_;
    
    my $url = "http://heasarc.gsfc.nasa.gov/cgi-bin/Tools/convcoord/convcoord.pl?Output=Batch&CoordType=$coordsys&CoordVal=".WEB::webcode($pos);
    my $val = VO::Service::GET($url);

    #print "url=$url<br>val=$val<br>" if $::debug;

    if (!defined($val)) {
        Browse::Utils::Error("Error: Unable to get position for $pos");
    }
    
    my @lines = split("\n", $val);
    my ($ra, $dec) = split('\|', $lines[1]);
    if (!defined($ra) || !defined($dec)) {
        Browse::Utils::Error("Error: Error in position for $pos");
    }
    return ($ra, $dec);
}    

1;
#########
#  EOF  #
#########
#$Log: BatFOV.pm,v $
#Revision 1.1  2005/04/05 13:11:48  lmm
#Initial check in
#
