# $Id: Java.pm,v 1.33 2005/10/31 17:18:32 lmm Exp $
# $Log: Java.pm,v $
# Revision 1.33  2005/10/31 17:18:32  lmm
# New call for java plotting class
#
# Revision 1.32  2005/03/23 19:33:53  lmm
# Removed note about server-side application being unavailable.
#
# Revision 1.31  2004/12/15 19:52:05  lmm
# Increased applet size to 1000 pixels
#
# Revision 1.30  2003/08/28 21:37:33  lmm
# Remove HEASARC footer
#
# Revision 1.29  2003/07/23 20:42:25  cwh
# Changed olegacy to heasarcdev.
#
# Revision 1.28  2002/12/10 21:36:47  cwh
# Added some quotes that were needed.
# Added labels and ids to form elements, added scope to table headers.
#
# Revision 1.27  2002/10/28 17:33:06  cwh
# Currently the server-side java plotting doesn't work so that link is
# commented out.
#
# Revision 1.26  2002/04/10 21:59:33  cwh
# Replaced hardwired system-specific directories with ones defined in Config.pm.
#
# Revision 1.25  2002/02/14 17:46:25  cwh
# HTML cleanup: Changed <font> elements to <span> elements, added quotes
#   around attribute values, etc.
#
# Revision 1.24  2001/11/07 23:34:18  cwh
# Moved everything except DBD/ into lib/Browse/, so as not to pollute the module
# namespace with our Sort, Search, CGI, etc.  This required putting Browse:: in
# front of every module call and package declaration.  Also any mod::new() had
# to be changed to mod->new().
#
# Revision 1.23  2001/07/31 14:49:45  cwh
# added alt text to plot image
#
# Revision 1.22  2001/07/09 01:02:45  cwh
# Removed HEASARC-specific paths and hostnames.
#
# Revision 1.21  2001/06/20 22:57:33  cwh
# Got rid of $::writeHeader in calls to ::Error.
#
# Revision 1.20  2001/06/08 19:46:38  cwh
# Now passing $::writeHeader to ::Error calls, so we don't get repeating headers.
#
# Revision 1.19  2001/05/24 16:18:37  cwh
# The link to the gif on the server was being created at $::host.gsfc.nasa.gov, but
# the $::host is now defined with a domain, so the domain was being added twice.
# Now it only adds the domain if the $::host doesn't already have it.
#
# Revision 1.18  2001/05/21 15:44:23  cwh
# Just changed the width of the applet.
#
# Revision 1.17  2001/05/17 02:35:55  tam
# Noted that Y-axis might not be specified.
# Support changes in parameters to allow server URL to
# be specified in input to Java.
#
# Revision 1.16  2001/05/07 15:57:55  cwh
# Tom's changes:
#   - added DoPlot: a switch that calls one of the three plot interfaces.
#   - added ServerSideForm: a new server-side Java plot interface.
#   - removed modifyselect, since we are no longer using sql here.
#   - instead of dealing with sql, now passing serialized request objects.
#
# Revision 1.15  2000/08/15 17:26:20  saima
# The plotting application now uses java 1.2.2 instead of java 1.1.8. The
#   server-side application does not require an X server to plot/create
#   the GIF. Instead, it uses a PJA package which can do the graphics
#   without an X server.
#
# Revision 1.14  2000/05/26 18:50:56  saima
# Added modifyselect() so that the query retrieves only the parameters
#   to be plotted. This makes the server-side plotting much faster and
#   allows plotting of many more rows of results.
#
# Revision 1.13  2000/05/24 19:13:52  saima
# Error checking is done if number of lines returned are <100. Added
#   -mx option to increase amount of virtual memory used to run java
#   application.
#
# Revision 1.12  2000/04/19 16:08:29  saima
# Added silk back to list of available hostnames to run java applications.
#
# Revision 1.11  2000/04/17 16:26:43  saima
# Modified so that errors from the application are reported to the user.
#
# Revision 1.10  2000/03/08 20:10:12  saima
# W3Browse to Browse name change.
#
# Revision 1.9  2000/02/08 15:36:38  saima
# Removed 'silk' from the list of machines to do server side
#   plotting. Added 'famtree' instead.
#
# Revision 1.8  1999/10/08 20:34:44  saima
# The $::java variable is used to indicate the java class path.
#   Since a process id is not necessarily unique, the $::pcount variable is
#   also used in creating the GIF file name.
#
# Revision 1.7  1999/09/17 19:57:06  saima
# Added setRemoteDisplay() which uses Xcheck to see if a machine
#   is available for running the java plotting application.
#   It sends email if no machines are available for remote host display.
#
# Revision 1.6  1999/09/13 18:23:59  saima
# Added names of archive jar files in the applet tag.
#
# Revision 1.5  1999/09/08 20:22:27  saima
# Modified &PlotApplication() so that sample-data information
#   is added correctly to the java call.
#
# Revision 1.4  1999/09/07 19:28:02  saima
# Added some more widths to applet window.
#
# Revision 1.3  1999/09/07 17:14:18  saima
# Modified so that the width of the java applet varies depending
#   on the size of the longest parameter name.
#
# Revision 1.2  1999/08/26 19:32:32  saima
# Modified Plot() with the new W3Browse Plotting Applet information.
#   Also, added PlotApplication() for the java server-side plotting.
#
# Revision 1.1  1998/12/22 20:39:10  saima
# Previosuly known as Java.pl.
#
# Revision 1.8  1998/07/15 19:13:42  saima
# Minor tweaks to code.
#
# Revision 1.7  1997/11/25 23:16:56  saima
# Added -T switch to perl version.
#
# Revision 1.6  1996/12/19 23:06:13  sabol
# Minor coding style change.
#
# Revision 1.5  1996/11/27 21:20:11  sabol
# Changed Java applet codebase to reflect new directory structure.
#
# Revision 1.4  1996/11/13 19:11:56  sabol
# Fixed bug that prevented the last field from ever showing up in the Java
#   applet's list of parameters to plot. The Java applet was expecting a
#   trailing "|" character in the parameter definition string.
#
# Revision 1.3  1996/10/25 21:25:09  sabol
# Now uses $java from w3config.pl to specify Java codebase.
#
# Revision 1.2  1996/10/24 16:03:37  sabol
# Added a constraint on the maximum number of rows to plot. Moved Java codebase
#   to directory inside the distribution.
#
# Revision 1.1  1996/10/21 21:19:40  sabol
# Added Java.pl which contains the code necessary to support the Java plotting
#   applet.
#
#-----------------------------------------------------------------------#
# High Energy Astrophysics Science Archive Research Center (HEASARC),
# NASA's Goddard Space Flight Center, Greenbelt, MD 20771, USA.
#
# You are free to use this code as you wish, but unless you change
#  it significantly, please leave the above name & address intact.
#-----------------------------------------------------------------------#
# Module Name:    Java.pm
# Module Author:  Saima Zobair, Raytheon ITSS
# Date:           09/99
# Project:        Browse : HEASARC
#=======================================================================#
# Module Description:
#
#
#
#=======================================================================#
# Outline:
#
#
#
#=======================================================================#

use strict;

package Browse::Java;

sub DoPlot {

    my ($ra, $dec, $numeric, $coordsys, $equinox, $request, $server, $in) = @_;


    if ($server =~ /on/i) {            # java server-side form
        ServerSideForm($ra, $dec, $numeric, $coordsys, $equinox, $request);
  
    } elsif ($server =~ /appmode/i) {  # java application
        PlotApplication($ra, $dec, $numeric, $coordsys, $equinox, $request, $in);
  
    } else {

        Plot($ra, $dec, $numeric, $coordsys, $equinox, $request);
    } 

    print "<hr>";

    Browse::Decor::Acknowledge();
    #Browse::Decor::Footer();
    Browse::Decor::EmailFooter();
    Browse::Decor::EndTags();
    exit();
}



sub ServerSideForm {

    my ($ra, $dec, $numeric, $coordsys, $equinox, $request) = @_;


    my ($params,$p);
    
    foreach $p (split(',',$numeric)) {
        $params .= "<option value='$p'>$p";
    }
    my $ra_opt = $params;
    $ra_opt =~ s/ value\=\'ra\'/ selected value='ra'/;
    my $dec_opt = $params;
    $dec_opt =~ s/ value\=\'dec\'/ selected value='dec'/;
    
    
    Browse::Decor::Header("Plot Server");
    print <<EOT;
<form method="GET" action="w3plot.pl">
<center>
  <table border="0">
    <tr>
      <td colspan="2" bgcolor="#bbbbcb" align="center">
      <span class="larger">
        <strong>Browse Plotting</strong><br>
        <input type="submit" value="  Plot  "> 
        <input type="reset"  value="  Reset  ">
      </span></td>
    </tr>
    
    <tr>
      <td bgcolor="#bbbbbb">
        <a href="#plottype">
	  <span class="large"><strong>Plot Type</strong></span></a>:
	<br>
	<dl>
          <dd><input name="plot-type" type="radio" id="scatter" value="scatter" checked>
	    <label for="scatter"><strong>Scatter</strong></label>
          <dd><input name="plot-type" value="histogram" id="histogram" type="radio">
	    <strong> 
	      <label for="histogram">Histogram</label> <label for="bins">#Bins</label>&nbsp;<input name="bins" id="bins" type="text" size=2> 
	    </strong>
          <dd><input name="plot-type" type="radio" id="cumulative" value="cumulative">
	  <label for="cumulative"><strong>Cumulative Histogram</strong></label>
          <dd><input name="plot-type" value="aitoff" id="aitoff" type="radio">
	  <label for="aitoff"><strong>Aitoff</strong></label>
	</dl>
      </td>
      <td bgcolor="#cbbbbb">
        <table>
	  <tr>
            <th scope="col">axis</th>
            <th scope="col"><label for="islog"><a href="#log">Log?</a></label></th>
            <th scope="col"><label for="parameters"><a href="#param">Parameters</a></label></th>
            <th scope="col"><label for="min"><a href="#min">Min</a></label></th>
            <th scope="col"><label for="max"><a href="#max">Max</a></label></th>
	  </tr>
          <tr>
	    <th scope="row">X:</th>
            <td><input type="checkbox" name="isxlog" id="islog" value='true'></td> 
            <td><select name="xaxis" id="parameters">$ra_opt</select></td>
            <td><input type="text" id="min" name="xmin" size="8"></td> 
            <td><input type="text" id="max" name="xmax" size="8"></td> 
          </tr>
          <tr>
	    <th scope="row">Y:</th>
            <td><input type="checkbox" name="isylog" id="islog" value='true'></td> 
            <td><select name="yaxis" id="parameters">$dec_opt</select></td>
            <td><input type="text" id="min" name="ymin" size="8"></td> 
            <td><input type="text" id="max" name="ymax" size="8"></td> 
          </tr>
        </table>
      </td>
    </tr>
    <tr>
      <td bgcolor="#dccccc" colspan="2" align="center">
        <input type="checkbox" name="issamp" id="issamp" value='true'> 
	<b>
	  <i>
	    <label for="issamp"><a href="#sample">Sample data by parameter</a></label> 
	    <select name="sample_param"> <option selected> $params
	    </select> 
	    <label for="criteria"> using intervals/value </label>
	  </i>
	</b> 
	<input name="criteria" type="text" id="criteria" size=10>
      </td>
    </tr>
  </table>

  <input type="hidden" name="ra"      value='$ra'>
  <input type="hidden" name="dec"     value='$dec'>
  <input type="hidden" name="numeric" value='$numeric'>
  <input type="hidden" name="request" value='$request'>
  <input type="hidden" name="server"  value="appmode">

</form>
</center>
<hr>
<h2> Help on Plotting </h2>
<b>
  <a name="plottype">Plot Type:
  </a>
</b> 
  The types of plots are Scatter, Histogram/Cumulative Histogram, 
  and Aitoff. 
<dl>
  <dt> Scatter
    <dd> Plots one parameter against another.
  <dt> Histogram 
    <dd> Plots a histogram for the parameter specified in the X-axis . The 
         number of bins can be specified.
  <dt> Cumulative Histogram
    <dd> Creates a cumulative histogram for the X-axis parameter.
  <dt> Aitoff
    <dd>  Plots the entire sky using equal area (Aitoff) projection.
</dl>
<p>

<dl>
  <dt> <a name="param">Parameters:</a>
    <dd> Here you can select the parameters to plot. 
  <dt> <a name="log">Log:</a>
    <dd> Makes the axis values logarithmic. 
  <dt> <a name="min">Min:</a>
    <dd> Sets the minimum value for plotted data.
  <dt> <a name="max">Max:</a>
    <dd> Sets the maximum value for plotted data.
  <dt> <a name="sample">Sample data by parameter:</a>
    <dd> Assigns different colors to a plot depending on the value of a
         specified parameter. The colon ':' symbol is used to specify ranges. The ',' 
         is used to separate different samples. Here are some examples of how to 
         specify samples:
         <ul>
	   <li> 200:300,500:800 (two ranges)
           <li> 400:500,100     (100 is a set value) 
         </ul> 
</dl>
EOT
} # eosub--ServerSideForm


sub PlotApplication {

    my ($ra, $dec, $numeric, $coordsys, $equinox, $request, $in) = @_;
    
    Browse::Decor::Header("Plot Server Results");

    #CLASSPATH
    $ENV{CLASSPATH} = $::root.$::java;
    my($classpath) = $::root.$::java;

    my($plottype);
    if ($in->{'plot-type'}     =~ /^scatter/i) {
       $plottype = "scatter";
    }elsif ($in->{'plot-type'} =~ /^aitoff/i) {
       $plottype = "aitoff";
    }elsif($in->{'plot-type'}  =~ /^histogram/i) {
       $plottype = "histogram";
    }elsif ($in->{'plot-type'} =~ /^cumulative/i) {
       $plottype = "cumulative";
    } else {
       Browse::Utils::Error("You have requested an unknown Plot Type of ". 
       $in->{'plot-type'}. " Are you by-passing the Browse interface?");
    }

    # untaint all variables 
    my($xaxis,$yaxis,$isxlog,$isylog,$bin,$xmin,$xmax,
       $ymin,$ymax,$sql,$issamp,$criteria,$sample_param);
       
    $xaxis = $1 if ($in->{'xaxis'} =~ /(\w+)/);
    $yaxis = $1 if ($in->{'yaxis'} =~ /(\w+)/);
    
    $sample_param = $1 if ($in->{'sample_param'} =~ /(\w+)/);
    
    $isxlog = $1 if ($in->{'isxlog'} =~ /(\w+)/);
    $isylog = $1 if ($in->{'isylog'} =~ /(\w+)/);
    $issamp = $1 if ($in->{'issamp'} =~ /(\w+)/);
    
    $bin  = $1 if ($in->{'bins'} =~ /(\d+)/); 
    $xmin = $1 if ($in->{'xmin'} =~ /([^\|\\\[\]\;\<\>\$\n\`]+)/);
    $ymin = $1 if ($in->{'ymin'} =~ /([^\|\\\[\]\;\<\>\$\n\`]+)/);
    $xmax = $1 if ($in->{'xmax'} =~ /([^\|\\\[\]\;\<\>\$\n\`]+)/);
    $ymax = $1 if ($in->{'ymax'} =~ /([^\|\\\[\]\;\<\>\$\n\`]+)/);
    
    $request  = $1 if ($request =~ /([^\"\n\`;]+)/);
    
    $criteria =  $1 if ($in->{'criteria'} =~ /([^\"\n\`;]+)/);
    
    $ra  =  $1 if ($ra  =~ /(\w+)/);
    $dec =  $1 if ($dec =~ /(\w+)/);

    print "<hr>";
    print "Running Plot Application. Please be patient...\n<br>";

    my($procnum)    =  $$ . $::pcount;
    my($gifFile)    =  "$::tarurlbase/w3plot-".$procnum.".gif";
    $::host .= ".gsfc.nasa.gov" unless $::host =~ /.*\..*\..*/;
    my($gifFileURL) =  (($::host =~ /heasarcdev/i) ?
                         "http://$::host/$::tarftpbase/" :
                         "ftp://$::host/") . $gifFile;
    if ($xaxis) {
        $request .= '&fields='.Browse::CGI::Encode($xaxis);
    }

    if ($yaxis) {
        $request .= '&fields='.Browse::CGI::Encode($yaxis);
    }

    my($cmd) = "$::jbin -mx526 -ms526".
               " -Xbootclasspath:$classpath:$::rtjar ".
               " -Duser.home=$classpath/com/eteks/fonts ".
               " -Djava.awt.fonts=$::jsystemfonts:$classpath/com/eteks/fonts ".
               " -Djava.awt.graphicsenv=com.eteks.java2d.PJAGraphicsEnvironment ".
               " -Dawt.toolkit=com.eteks.awt.PJAToolkit ".
               " -Djava2d.font.usePlatformFont=false ".
               " heasarc.w3browse.plot.W3Plot ".
               " procnum=$procnum plot-type=$plottype bin=$bin ".
               " xaxis=$xaxis yaxis=$yaxis ".
               " xlog=$isxlog ylog=$isylog ".
               " xmin=$xmin xmax=$xmax ymin=$ymin ymax=$ymax ".
               " ra=$ra dec=$dec isSample=$issamp criteria=$criteria ".
               " sample_param=$sample_param request='$request'".
               " urlbase='http://$::host/$::cgi/'".
	       " url=w3server.pl";

	       
     #print "Command is: <br>$cmd<br>\n";
	       
     $ENV{JAVA_COMPILER} = "NONE";
     my(@mm) = `$cmd 2>$::tarftpbase/$::tarurlbase/javaerr `;

     
     #error checking
     #if there is an error it should have popped up in the first 
     #few lines. No need to join if the output is large!
     
     if(scalar(@mm) < 300) { 
       my($out) = join('|',@mm);

       # for some reason a case-insensitive expression does not work here
       # $out =~ /Error/i randomly dies!
       if($out =~ /Error/) {
        Browse::Utils::Error(substr($out,index($out,'Error'))); 
       }
     }
     print "\n <P> <a href='$gifFileURL'><img alt='plot' src='$::tarftpbase/$gifFile'></a>";

} #eosub--PlotApplication
#------------------------------------------------------------------------

sub Plot {
    # Function input: sql query string, filter string and table location

    my ($ra, $dec, $numeric, $coordsys, $equinox, $request) = @_;

    # Configuration variable:
    my($max_rows) = 20000;	# Maximum number of rows to plot.

    # This subroutine uses the following global variable as defined in
    # w3config.pl:
    my($java) = $::java;

    #set size of applet 
    #my $width = 800;
    my $width = 1000;
    
    Browse::Decor::Header("Plot Applet");
    
    my ($nurl) = "w3plot.pl?request="   . Browse::CGI::Encode($request).
	                  "&ra="        . Browse::CGI::Encode($ra).
			  "&numeric="   . Browse::CGI::Encode($numeric).
			  "&dec="       . Browse::CGI::Encode($dec).
			  "&Equinox="   . Browse::CGI::Encode($equinox).
			  "&Coordinate=". Browse::CGI::Encode($coordsys).
			  "&url="       . Browse::CGI::Encode($::serverURL).
			  "&server=on";
    
    
#    print <<EOT;
#<b> This Java Applet requires a Java 1.1 capable browser. </b> NOTE: The server-side plotting application is temporarily unavailable.<p>
#EOT
    print <<EOT;
<b> This Java Applet requires a Java 1.1 capable browser. </b> 
EOT
#If you do not
#see the applet, please click on: <a href="$nurl">Java Server-Side Plotting</a> 
#to begin plotting.</b><p>

    print <<EOT;
<table border="15">
  <tr><td>
     <applet  code="heasarc.w3browse.plot.W3PlotA" 
              width="$width" height="500" codebase="$::java">
       <param name="request" value='$request'>
       <param name="ra"      value='$ra'>
       <param name="dec"     value='$dec'>
       <param name="url"     value='$::serverURL'>
     If you had a java-enabled browser, you would see an applet here
     Sorry. Your browser is either not Java capable or Java has been disabled.
     Look at the network and security preferences of your Web browser to see
     if you can turn on Java.
     </applet>
   </td></tr>
</table>
<br>
EOT
    return;

} #eosub--Plot
#------------------------------------------------------------------------
1;
#########
#  EOF  #
#########
