# $Id$

use strict;

package Browse::ReallySimpleDisplay;

use vars qw( @ISA );
@ISA = qw( Browse::Display );

# Print out the very top of the page.  From
# the HTTP headers until we begin displaying
# information from a particular table.

sub pageHeader {

    my ($self, $navtrail) = @_;
    my $formname="w3hdprods";
    $$self{"class"} = "linkedtable"; 

    if ($$self{"text"}) {
        print Browse::CGI::Header();
    } else {
        print Browse::CGI::Header();
print <<EOF;
    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
    <html><head>
    <link rel="stylesheet" href="$::w3bdocs/w3browsetable.css" title="colortable style" type="text/css" media="screen">
    <link rel="alternate stylesheet" href="$::w3bdocs/w3browse.css" title="scrolltable style" type="text/css" media="screen">
    <link rel="stylesheet" href="$::w3bdocs/w3browseprint.css" title="print style" type="text/css" media="print">
    </head>
    <body bgcolor="ffffff" text="#090909"
          link="#0505ff" vlink="#ff0000" alink="#c0f0c0">
EOF

        #Browse::Decor::Header("results",0); #dont close table, cols
        Browse::ValidateInput::checkResults($formname);
       # unless ($navtrail=~ /\w/) { 
       #     my $referrer = ($ENV{HTTP_REFERER} or "/".$::cgiurl."/w3browse.pl");
       #     $navtrail = "<a class='navpast' href='$referrer'> Choose Tables</a>";
       # }
       # print "$navtrail &gt; <span class='navcurrent'>Search Results</span> &gt; <span class='navfuture'>Choose Data Products</span><br>";
       # if ($ENV{REQUEST_METHOD} eq "GET") {
       #     $navtrail .= " &gt; &lt;a class='navpast' href='".$ENV{SCRIPT_NAME}.'?'.$ENV{QUERY_STRING}."'&gt;Search Results&lt;/a&gt;";
       # } else {
       #     $navtrail .= " &gt; Search Results";
       # }
       # $navtrail =~ s/\</&lt;/g;
       # $navtrail =~ s/\>/&gt;/g;
    }
    print "\n<form method='POST' target='_blank' name='$formname' action='w3hdprods.pl'>\n";
#    print "\n<input type='hidden' name='navtrail' value='$navtrail'>\n";
    print "<input type='hidden' name='Coordinates' value='".$$self{"coordsys"}."'>\n";
    print "<input type='hidden' name='Equinox' value='".$$self{"equinox"}."'>\n";
    print "<input type='hidden' name='input' value='".$$self{"input"}."'>\n";
}

# Print out everything at the bottom of the table
# after the last table information.

sub pageFooter {
    my ($self) = @_;
    
   
    $self->closeTable();

#    Browse::Results::Footer();
#    Browse::Decor::Footer();
#    Browse::Results::Heraform($$self{"input"});
    print "</body></html>\n";
}


# This prints out the columns at the beginning of each HTML table block.

sub printColumnHeader {

    my ($self, $names) = @_;
    
    my $meta  = $$self{"meta"};
    my $trans = $$self{"transform"};
    my $longs = $$trans{"longs"};
    my ($links,$html);

    print "<div class='lscrolltable'>" unless $$self{"intable"};
    ($$self{"skipfield"},$links,$html) =
      Browse::Results::PrintTableParams($$meta{"table"}, $$meta{"tableinfo"},
         $$meta{"sortable"}, $names, $$self{"unitFlds"}, $longs,
         $$self{"offset_var"});
    my $bg;
    if ($$meta{"table"} =~ /\//) {   # if there is a '/' in the name, must be VizieR
        $bg = "class='Vizier'";
    } 
    print "\n<table border='0' rules='cols' class='thinbordertable' bgcolor='#000000' title='Query results for ".$$meta{"table_info"}{"table_description"}."'><thead>\n<tr $bg>$html</tr>"; #lmm
    #print "\n<table border='1' rules='cols' class='thinbordertable' title='Query results for ".$$meta{"table_info"}{"table_description"}."'><thead>\n<tr $bg>$html</tr>"; #lmm

    my $fld;
    $$self{"related_links"} = $links;

    # Handle long strings
    foreach $fld(@$longs) {
        my $span = $#$names - $$self{"skipfield"} - 1;
	
        if ($span <= 0) {
            $span = 1;
        }

        print "<tr><th class='datahead' colspan='2'></th><th scope='col' colspan='$span' align='left'>";
	my $fn = $$names[$fld];
	my $doc = $$meta{"tableinfo"}{"table_document_url"};
	print "<a target='helpwin' href='$doc#$fn'> $fn </a>";
	print "</th></tr>\n";
    }
        print "</thead>\n";	
 
}


sub YourSearchWas {
}

## Successful load
1;
# $Log$
