# $Id: SimpleDisplay.pm,v 1.7 2007/10/09 14:10:50 lmm Exp $

use strict;

package Browse::SimpleDisplay;

use vars qw( @ISA );
@ISA = qw( Browse::Display );

# Print out the very top of the page.  From
# the HTTP headers until we begin displaying
# information from a particular table.

sub pageHeader {

    my ($self, $navtrail) = @_;
    my $formname="w3hdprods";
    $$self{"class"} = "linkedtable"; 

    if ($$self{"text"}) {
        print Browse::CGI::Header();
    } else {
        #Browse::Decor::Header("results",0); #dont close table, cols
        Browse::Decor::Header($$self{"popupFrom"} ,0,0,0,$$self{"class"}); 
              #dont close table, cols, no banner, style for header

        Browse::ValidateInput::checkResults($formname);
        unless ($navtrail=~ /\w/) { 
            my $referrer = ($ENV{HTTP_REFERER} or "/".$::cgiurl."/w3browse.pl");
            $navtrail = "<a class='navpast' href='$referrer'> Choose Tables</a>";
        }
        print "$navtrail &gt; <span class='navcurrent'>Search Results</span> &gt; <span class='navfuture'>Choose Data Products</span><br>";
        if ($ENV{REQUEST_METHOD} eq "GET") {
            $navtrail .= " &gt; &lt;a class='navpast' href='".$ENV{SCRIPT_NAME}.'?'.$ENV{QUERY_STRING}."'&gt;Search Results&lt;/a&gt;";
        } else {
            $navtrail .= " &gt; Search Results";
        }
        $navtrail =~ s/\</&lt;/g;
        $navtrail =~ s/\>/&gt;/g;
    }
    print "\n<form method='POST' target='_blank' name='$formname' action='w3hdprods.pl'>\n";
    print "\n<input type='hidden' name='navtrail' value='$navtrail'>\n";
    print "<input type='hidden' name='Coordinates' value='".$$self{"coordsys"}."'>\n";
    print "<input type='hidden' name='Equinox' value='".$$self{"equinox"}."'>\n";
    print "<input type='hidden' name='input' value='".$$self{"input"}."'>\n";
    my ($popup)=$$self{"popupFrom"};  #lmm
    print "<input type='hidden' name='popupFrom' value='$popup'>\n";

}

# Print out everything at the bottom of the table
# after the last table information.

sub pageFooter {
    my ($self) = @_;
    
   
    $self->closeTable();

#    Browse::Results::Footer();
#    Browse::Decor::Footer();
#    Browse::Results::Heraform($$self{"input"});
    #print "</body></html>\n";
    Browse::Decor::EndTags();
}

sub legend {print "<br>";}

# This prints out the columns at the beginning of each HTML table block.

sub printColumnHeader {

    my ($self, $names) = @_;
    
    my $meta  = $$self{"meta"};
    my $trans = $$self{"transform"};
    my $longs = $$trans{"longs"};
    my ($links,$html,$dataid, $dataid_prefix);

    print "<div class='lscrolltable'>" unless $$self{"intable"};
    

    my $results = $self->results();
    if ($results) {
    ($$self{"skipfield"},$links,$html, $dataid, $dataid_prefix) = 
	  $results->PrintTableParams($$meta{"table"}, 
	  $$meta{"tableinfo"}, $$meta{"sortable"}, $names, $$self{"unitFlds"},
	  $longs, $$self{"offset_var"},$$self{"sortcolumn"});


    }
    #($$self{"skipfield"},$links,$html) =
      #Browse::Results::PrintTableParams($$meta{"table"}, $$meta{"tableinfo"},
         #$$meta{"sortable"}, $names, $$self{"unitFlds"}, $longs,
         #$$self{"offset_var"},$$self{sortcolumn});

    my $bg;
    if ($$meta{"table"} =~ /\//) { # if '/' in the name, must be VizieR
        $bg = "class='Vizier'";
    } 
    print "\n<table border='0' rules='cols' bgcolor='#000000' class='thinbordertable' title='Query results for ".$$meta{"table_info"}{"table_description"}."'><thead>\n<tr $bg>$html</tr>";

    my $fld;
    $$self{"related_links"} = $links;

    # Handle long strings
    foreach $fld(@$longs) {
        my $span = $#$names - $$self{"skipfield"} - 1;
	
        if ($span <= 0) {
            $span = 1;
        }

        print "<tr><th class='thinborderhead' colspan='2'></th><th class='thinborderhead' scope='col' colspan='$span' align='left'>";
	my $fn = $$names[$fld];
	my $doc = $$meta{"tableinfo"}{"table_document_url"};
	print "<a target='helpwin' href='$doc#$fn'> $fn </a>";
	print "</th></tr>\n";
    }
        print "</thead>\n";	
 
}

# Add Redisplay options lmm
sub YourSearchWas {
   my ($self) = @_;
   my($string) ="<p><table><tr><td align='right'>" .
	"<input type='submit' name='redisplay' value='Redisplay'>" .
	"</td><td>as <select name='displaymode'>";

    $string .= "<option value='Display'>HTML Table"
	 unless ref($self) =~ /::Display/;

    $string .= "<option value='TextDisplay'>Text Table" 
	unless ref($self) =~ /::Text/;

    $string .= "<option value='FitsDisplay'>FITS Table" 
	unless ref($self) =~ /::Fits/;

    $string .= "<option value='XMLDisplay'>astrores XML" 
	unless ref($self) =~ /::XML/;

    $string .= "<option value='VODisplay'>VOTable XML" 
	unless ref($self) =~ /::VO/;
    $string .= "<option value='ExcelDisplay'>Excel-compatible" 
	unless ref($self) =~ /::ExcelDisplay$/;
    $string .= "<option value='PureTextDisplay'>Pure Text" 
	unless ref($self) =~ /::PureTextDisplay$/;


    $string .= "</select></td></tr>";
    $string .="<tr><td align='left' colspan='2'><input type='submit' " .
	"name='redisplay' value='Printer-Friendly Version'></td>" 
	unless ref($self) =~ /::PureTextDisplay$/;

    $string .="<tr><td align='left' colspan='2'><input type='reset'></td></tr>";
    $string .= "</table><p>";
    print $string;

}

sub beforeNewTable {}
sub afterTable {}

## Successful load
1;
# $Log: SimpleDisplay.pm,v $
# Revision 1.7  2007/10/09 14:10:50  lmm
# Added empty methods beforeNewTable() and afterTable() .
#
# Revision 1.6  2006/06/23 18:44:55  lmm
# Made change to Results routine call since results is now a class
#
# Revision 1.5  2003/09/12 20:45:20  lmm
# Corrected the documentation link for 2nd table header row
#
# Revision 1.4  2003/09/12 17:30:39  lmm
# Added additional <td> and <th> color styles to tables with
#    2 display table rows for each query results row  (eg. tables with
#    long string parameters like HETE2GRB)
#
# Revision 1.3  2003/09/09 17:50:28  lmm
# Using new style (thinbordertable) for results table
#
# Revision 1.2  2003/08/29 14:45:36  lmm
# Defined text and style for page header and added Redisplay options
#
# Revision 1.1  2003/07/31 18:51:04  cwh
# This is a new display mode for linked tables.
#
