# $Id: saveFile.pm,v 1.13 2005/01/27 16:18:22 lmm Exp $

use strict;
use IO::Socket;
use LWP;
use LWP::Simple;

package Browse::saveFile;
#----------------------------------------------------------------------------

sub saveFile {
    my ($in) = @_;
#$::debug=1;
#    my %cookies;
#    if ($$in{"controlid"} or $$in{"password"}) {
#      %cookies = (heracontrolid => $$in{"controlid"},
#                  herapassword => $$in{"password"});
#    }
#    Browse::Decor::Header("Save to Hera",undef,undef,\%cookies);
    #Browse::Decor::Header("Save to Hera",undef,undef);

    my($stylecolor) = "heratable";
    Browse::Decor::Header("Save to Hera",0,0,0,$stylecolor);
    print "<h1>TESTING, pardon the dust</h1>\n" if $::debug;

    my $maintainer = 'lmm@milkyway.gsfc.nasa.gov';
    $$in{"controlid"} =~ /([-\w. ]+)/; #untaint controlid
    my $controlid = $1 if $$in{"controlid"};
    $$in{"password"} =~ /([-\w. ]+)/; #untaint password
    my $password = $1 if $$in{"password"};
    my $newuser=0;
    $newuser = 1 if $$in{"newuser"} =~ /on/;

    if (!$controlid) { 
       #first time through, or no controlid given
       my $filelist = get_file_list($in);
       unless (scalar(@$filelist)) {
           print "<b>No files found.\n<br>";
           print "<br>This may be because the data products for the row you ".
             "selected are not public yet, or because no ".
             "products exist for the row.".
             "<br>You may wish to select the \"Preview\" button on ".
             "the previous page to see a list of the data products that are ".
             "available. \n</b>";
       } else {
           printform($filelist);
       }
    } else {   # second time through
       my @filelist = split(',',$$in{"filelist"});
       if (scalar(@filelist)) {
           send_link_request($controlid,$password,$newuser,\@filelist);
       } else {
           print "Error: didn't get the list of files to copy!<br>\n";
       }
    }

    Browse::Decor::EmailFooter();
    Browse::Decor::EndTags();
    exit;

} # end sub saveFile

sub printform {

  my ($filelist,$controlid,$password,$newuser) = @_;

  if (!$controlid or !$password) { # try to read cookie
#    #taken from CGI::Cookie
#    my $raw_cookie = $ENV{HTTP_COOKIE} || $ENV{COOKIE};
#    my(@pairs) = split("; ",$raw_cookie);
#    foreach (@pairs) {
#       my($key,$value) = split("=");
#       $key = Browse::CGI::Decode($key);
#       $value = Browse::CGI::Decode($value);
#       $controlid |= $value if $key =~ /heracontrolid/;
#       $password |= $value if $key =~ /herapassword/;
#    }
  }

  $newuser = "checked" if $newuser;
  print "<p><b>".scalar(@$filelist) ." data product files were found ".
    "matching your criteria.\n<br>".
    "<form name='savetohera' method=POST action='/$::cgiurl/w3hdprods.pl'>\n".
    "In order to copy these to the Hera user area, a login for Hera is ".
    "required.</b></p>\n".
    "<p>(If you've never used Hera before, enter the username ".
    "and password you'd like to use, and check the 'new user' box.): </p>\n".
    "<p><table><tr><td><label for='controlid'>Hera user name: </label>" .
    "<input type='text' name='controlid' id='controlid' value='$controlid'>" .
    "</td><td></td></tr>\n".
    "<tr><td width=\"35%\"><label for='password'>Hera password: </label>" .
    "<input type='password' name='password' id='password' value='$password'>" .
    "</td><td>New Users: Please use only alphanumeric characters " .
    "(A-Z,a-z,0-9) and special characters .  _  - (period, underscore," .
    " dash)</td></tr></table> \n".
    "<label for='newuser'>Check this box if this a new user name: </label>" .
    "<input type='checkbox' name='newuser' id='newuser' $newuser></p>\n".
    "<p><input type='submit' name='Save to Hera' value='Save to Hera'>\n".
    " <a target='helpwin' " .
    "href='http://heasarc.gsfc.nasa.gov/docs/software/hera.html'>" .
    "Intro to Hera</a>\n".
    "<input type='hidden' name=\"filelist\" value=".
       join(',',@$filelist)."><br>\n".
    "</form></b></p>\n";
}

sub get_file_list {
my ($in) = @_;

#my (@targets) = split("\0",Browse::CGI::Decode($in->{'Target'}));
my (@targets) = split("\0",$in->{'Target'});

my %keys_by_table = ();
foreach my $target (@targets) {
#   $target = Browse::CGI::Decode($target);
   my ($table,$ukey) = split(/\|\|\|/,$target,2);
   $keys_by_table{$table} .= $ukey;
}

my %dpsets_by_table = ();
my @files=();
foreach my $key (keys %$in) {
   my (@dpsets) = split("\0",$$in{$key}) if $key =~ /^RetrieveSet/;
   my ($table) = $key =~ /RetrieveSet_(.*)/;
   $dpsets_by_table{$table} = \@dpsets;
   #push(@files,split("\0",Browse::CGI::Decode($$in{$key}))) if $key=~/^File/;
   push(@files,split("\0",$$in{$key})) if $key=~/^File/;
}

my @filelist = ();
my $filelist = \@filelist;

foreach my $table (keys %keys_by_table) {
   print "table=$table\n<br>" if $::debug;
   my $sets = $dpsets_by_table{$table};
   my $ids = $keys_by_table{$table};
   my @idarr = split('\|\|', $ids) if defined($ids);

   my %setHash=();
   if (defined($sets) ) {
       my $set;
       foreach $set(@$sets) {
           print "set=$set\n<br>" if $::debug;
           $set =~ s/^\s*|\s*$//g;
           $setHash{$set} = 1;
       }
   }

   my $dpquery=new Browse::DPQuery($table);

   foreach my $id (@idarr) { 
      print "id=$id<br>\n" if $::debug;

      my $bighash = $dpquery->getDataProducts([$id],[]);

      foreach my $key (keys(%$bighash)) {
          next if $key=~ /^set_descriptions$/i;
          print "bighash key=$key<br>\n" if $::debug;
          my $littlehash = $$bighash{$key};
          Browse::Utils::DumpRef($littlehash) if $::debug;
          my $set;

          foreach $set(keys(%$littlehash)) {
          print "set: $set<br>\n" if $::debug;
              if (defined($sets) && !$setHash{$set}) {
   	          next;
      	      }
              my $list = $$littlehash{$set};
      	      foreach my $entry(@$list) {
                  my $format=$$entry{'dp_format'};
                  my $url=$$entry{'dp_url'};
                  print "format=$format<br>\n" if $::debug;
	          if ( $format !~ /^DIR/) {
	    
	              my $file = $url;
	              $file=~ s/ftp\:\/\/(heasarc|heasarcdev|legacy|olegacy).gsfc.nasa.gov\//\/FTP\//;
		      push(@$filelist,$file);
                      print "pushing file=$file<br>\n" if $::debug;
	          } elsif ($format =~ /^DIR/) {
	              $url=~ /ftp\:\/\/(heasarc|heasarcdev|legacy|olegacy).gsfc.nasa.gov\/(.*)/;
   		      my $dir = "$2";
		      $dir .= "/" if $dir !~ /\/$/; 
		      $dir = "/FTP/". $dir unless $dir =~/^\/FTP\//;
                      print "$url ->> is dir $dir<br>\n" if $::debug;
		      $filelist = descendtree($dir,$filelist);
	          } # if format
	      } # end foreach entry
          } # end foreach set
      } # end foreach key

   } # end foreach id

} # end foreach table


# these File inputs come from the actual product listing from w3hdprods.pl

if (@files) {
   my $file;
   foreach $file (@files) {
       print "got file $file<br>\n" if $::debug;
       if ($file =~ /\/$/) {
          print "was directory $file<br>\n" if $::debug;
          $filelist = descendtree($file,$filelist);
       } else {
          print "pushing $file<br>\n" if $::debug;
          #$file = "/FTP".($file=~ /^\//? "/": "").$file;
          push(@$filelist, $file);
       }
   }
} # end if files


print "filelist=@$filelist\n\n" if $::debug;
# get list of xte filenames from the tarfile that xteTar.pl creates
foreach my $file (@$filelist) {
   print "<br>looking at $file\n" if $::debug;
   if ($file =~ /xteTar\.pl/) { 
       print "matches xteTar\n" if $::debug;
       $file .= "&listonly=on";
       my @outlist = split("\n",LWP::Simple::get($file));
       push(@$filelist,@outlist);
   }
}

# get rid of the xteTar entry in file list
#print "filelist=@$filelist\n\n" if $::debug;
@$filelist = grep(!/xteTar\.pl/,@$filelist);
#print "filelist=@$filelist\n\n" if $::debug;

return $filelist;

} # end sub get_file_list

sub descendtree {

    my ($dir,$filelist) = @_;
    print "descending $dir<br>\n" if $::debug;
    
    #if (opendir(DIR, "/FTP/$dir")) {
    if (opendir(DIR, "$dir")) {
        my @files = readdir(DIR);
        closedir(DIR);
	my $file;
	foreach $file (@files) {

	    next if $file =~ /^\./; # ignore hidden files

	    #if (-d "/FTP/$dir$file") {
	    if (-d "$dir$file") {
	        $filelist = descendtree("$dir$file/",$filelist);
	    } else { 
		#push(@$filelist, "/FTP/$dir$file");
		push(@$filelist, "$dir$file");
                print "pushing $dir$file<br>\n" if $::debug;
	    }
	}
    } else {
        print "Error opening directory: $dir\n";
    }
return $filelist;
} # end sub descendtree


sub send_link_request {

  my ($controlid,$password,$newuser,$filelist) = @_;
  print "got controlid=$controlid<br>password=$password<br>newuser=$newuser".
        "<br>filelist=$filelist<br>\n" if $::debug;


  # variables
  my $heraserver = 'herasrv.gsfc.nasa.gov'; # heraserver machine
  my $port = 9468; # port on heraserver
  my $id = 'HeraBrowser'; # string to identify me to the Hera manager
  my $key = rand(); # session key

  # Check that we have what we need.
  # We expect $controlid, $password, $newuser (1 or 0), and 
  #    $filelist (ref to array of filenames)
  quit("Please enter a username.<br>\n",$filelist) unless $controlid =~ /\w/;
  quit("Please enter your password. (For new users, enter ".
       "desired password.)<br>\n",$filelist,$controlid,$password,$newuser) 
       unless $password =~ /\w/;
  quit("No FITS files found to save.  Please go back and reselect.<br>\n") 
       unless $filelist =~ /\w/;

  # Check password for valid characters
  if ($newuser) {
     my($testword)=$password; 
     #--- change valid non-alphas to alphas then check for any other non-alphas
     $testword =~ s/\./x/g;
     $testword =~ s/\-/x/g;
     $testword =~ s/_/x/g;
     if ($testword =~ /\W/ ) {
        quit("Please go back & re-enter your password. Use only alphanumeric " .
	   "characters and . - _ (period, dash, underscore."); 
     } 
  }

  print "You selected ".scalar(@$filelist)." files total.<br>\n" if $::debug;
  my @remotefiles = grep (/:\/\//,@$filelist);
  my @localfiles = grep (!/:\/\//,@$filelist);
  print "You selected ".scalar(@remotefiles)." remote files.<br>\n" if $::debug;
  print "You selected ".scalar(@localfiles)." local files.<br>\n" if $::debug;

  my $heramgr = get_socket_conn($heraserver,$port);
  establish_channel($heramgr,$id,$key);
  authenticate_user($heramgr,$id,$key,$controlid,$password,$newuser,$filelist);
  my $lcount = make_links($heramgr,$id,$key,\@localfiles,$controlid)
	 if scalar(@localfiles);
  my $rcount = send_data_files($heramgr,$id,$key,\@remotefiles,$controlid) 
	if scalar(@remotefiles);
  close_channel($heramgr,$id,$key,$lcount,$rcount,$controlid,$password);

} # end sub send_link_request


# Get socket connection
sub get_socket_conn {
  my ($heraserver,$port) = @_;
  my $heramgr = new IO::Socket::INET (PeerAddr => $heraserver,
                                     PeerPort => $port,
                                     Proto    => 'tcp');

  unless ($heramgr) {
    mailalert("Unable to contact Hera manager.\n $!");
    quit("Unable to contact Hera manager.  Reason: $!<br>\n".
         "Mail has been sent to the maintainers.<br>\n");
  }
  print "got socket connection to $heraserver<br>\n" if $::debug;
  return $heramgr;
} #end sub get_socket_conn


# Establish Trust Channel
sub establish_channel {
  my ($heramgr,$id,$key) = @_;
  print $heramgr "EstablishTrustChannel $id $key\n";
  print "sent <b>EstablishTrustChannel $id $key</b><br>\n" if $::debug;
  my $ans = <$heramgr>;
  print "got <b>$ans</b><br>\n" if $::debug;
  unless ($ans =~ /AGREED/) {
     mailalert("EstablishTrustChannel $id $key failed.\n $!\n $ans");
     quit("Can't establish trusted channel with Hera manager: $ans<br>\n".
          "Mail has been sent to the maintainers.<br>\n");
  }
  print "got trusted channel<br>\n" if $::debug;
}


# Authentication
sub authenticate_user {
  my ($heramgr,$id,$key,$controlid,$password,$newuser,$filelist) = @_;
  print $heramgr "Authentication $id $key $controlid $password\n";
  print "sent <b>Authentication $id $key $controlid $password</b><br>\n" 
        if $::debug;
  my $ans = <$heramgr>;
  print "got <b>$ans</b><br>\n" if $::debug;

  if ($ans =~ /NEW_RECONFIRM/ and !$newuser) {
    # user name not found, but user said they were not new
    print "user name not found, but user said they existed<br>\n" if $::debug;
    # cancel new user
    print $heramgr "RequestCancelUser $id $key $controlid\n";
    print "sent <b>RequestCancelUser $id $key $controlid</b><br>\n" if $::debug;
    $ans = <$heramgr>;
    print "got <b>$ans</b><br>\n" if $::debug;
    unless ($ans =~ /DONE/) {
       mailalert("RequestCancelUser $key $controlid failed: $ans");
    }
    quit("User $controlid is not an existing user.  Please ".
         "check that the name is entered correctly.<br>\n",$filelist,
         $controlid,$password,$newuser);
  } elsif ($ans =~ /FAIL/ and $newuser) {
    # user name must already exist
    print "user name found, but user said they were new<br>\n" if $::debug;
    quit("Username $controlid is already taken.  Please try ".
         "another username.<br>\n",$filelist);
  } elsif ($ans =~ /FAIL/ and !$newuser) {
    # user/passwd fails, user is not new
    quit("The username and password you typed do not match our records.  ".
         "Please try again.<br>\n",$filelist,$controlid,$password,$newuser);
  } elsif ($ans =~ /NEW_RECONFIRM/ and $newuser) {
    # Create User Space if new user
    # user name not found, and user said they were new - create user space
    print "user name not found, and user said they were new - ".
          "create user space<br>\n" if $::debug;
    print $heramgr "CreateUserSpace $id $key $controlid\n";
    print "sent <b>CreateUserSpace $id $key $controlid</b><br>\n" if $::debug;
    $ans = <$heramgr>;
    print "got <b>$ans</b><br>\n" if $::debug;
    unless ($ans =~ /DONE/) {
       mailalert("CreateUserSpace $id $key $controlid failed: $ans");
       quit("Unable to create your user space. <br>\nMail has been sent to the ".
         "maintainers.<br>\n");
    }
    print "created new user space<br>\n" if $::debug;
  }
  print "authenticated<br>\n" if $::debug;
} # end sub authenticate_user


# Make Links
sub make_links {
  my ($heramgr,$id,$key,$filelist,$controlid) = @_;
  my $count=0;
  my $faillog='';
  my %seen;
  print "Making links to ".(scalar(@$filelist))." selected files in your ".
        "Hera area:<br><br>\n";
  foreach my $file (@$filelist) {
     print $heramgr "MakeLink $id $key $controlid $file\n";
     print "sent <b>MakeLink $id $key $controlid $file</b><br>\n" if $::debug;
     my $ans = <$heramgr>;
     print "got <b>$ans</b><br>\n" if $::debug;
     if ($ans !~ /DONE/) {
        $faillog .= "Unable to make link! file=$file: $ans\n";
        print "Unable to create link to file $file: $ans<br>\n";
     } else {
        $count++;
        print "Created link to file $file: $ans<br>\n" if $::debug;
        my $percentdone = int($count * 100 / scalar(@$filelist));
        if ((scalar(@$filelist) >500) and (($percentdone % 10) == 0) and 
            !$seen{$percentdone}) {
            $seen{$percentdone}++;
            print "$percentdone% &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>\n";
        }
     }
  }
  mailalert("MakeLink failed for user $controlid: $faillog") 
      if $faillog =~ /\w/;
  print "done creating links<br>\n" if $::debug;
  return $count;

} # end sub make_links

# send remote data files
sub send_data_files {
  my ($heramgr,$id,$key,$filelist,$controlid) = @_;
  my $count=0;
  my $faillog='';
  my %seen;
  my $filetype="DATA_FILE";
  print "Copying ".(scalar(@$filelist))." selected remote data files to your ".
        "Hera area:<br><br>\n";
  foreach my $file (@$filelist) {
   my ($filename) = $file =~ /.*:\/\/(.*)/;
     # send start notice
     print $heramgr "DataTransmissionStart $id $key $controlid $filetype $filename\n";
     print "sent <b>DataTransmissionStart $id $key $controlid $filetype $filename</b><br>\n" if $::debug;
     my $ans = <$heramgr>;
     print "got <b>$ans</b><br>\n" if $::debug;
     if ($ans !~ /DONE/i) {
        $faillog .= "Unable to start transfer! file=$filename: $ans\n";
        print "Unable to copy remote file $filename: $ans<br>\n";
     } else {
        print "Sent start notice for file $filename: $ans<br>\n" if $::debug;
        print "Copying $filename...\n";
     }

     # get and send the file
     print "saveFile::filename=$file<br>\n" if $::debug;
     my $ua = new LWP::UserAgent;
     my $request = HTTP::Request->new(GET => $file);
     $request->header(Accept => 'image/*');
     my $response = $ua->request($request,
       sub {
         print $heramgr "DataLength $id $key ".length($_[0]).
                        " $controlid $filename\n";
         print $heramgr $_[0];
         print "Sent DataLength $id $key ".length($_[0]).
                 " $controlid $filename\n" if $::debug;
         $ans = <$heramgr>;
         print "got <b>$ans</b><br>\n" if $::debug;
         if ($ans !~ /DONE/i) {
            $faillog .= "Unable to send data for file $filename: $ans\n";
            print "Unable to send data for $filename: $ans<br>\n";
         } 
       }
     );

                 
     # send end notice
     print $heramgr "DataTransmissionEnd $id $key $controlid $filename\n";
     print "sent <b>DataTransmissionEnd $id $key $controlid $filename</b><br>\n" if $::debug;
     $ans = <$heramgr>;
     print "got <b>$ans</b><br>\n" if $::debug;
     if ($ans !~ /DONE/i) {
        $faillog .= "Unable to close transfer! file=$filename: $ans\n";
        print "Unable to copy remote file $filename: $ans<br>\n";
     } else {
        $count++;
        print " Done.<br><br>\n";
        my $percentdone = int($count * 100 / scalar(@$filelist));
        if ((scalar(@$filelist) >500) and (($percentdone % 10) == 0) and
            !$seen{$percentdone}) {
            $seen{$percentdone}++;
            print "$percentdone% &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>\n";
        }
     }
  }
  mailalert("DataTransmission failed for user $controlid: $faillog")
      if $faillog =~ /\w/;
  print "done creating links<br>\n" if $::debug;
  return $count;

} # end sub send_data_files


# Close Trusted Channel
sub close_channel {
  my ($heramgr,$id,$key,$lcount,$rcount,$controlid,$password) = @_;
  print $heramgr "CloseTrustedChannel $id $key\n";
  print "sent <b>CloseTrustedChannel $id $key</b><br>\n" if $::debug;
  my $ans = <$heramgr>;
  print "got <b>$ans</b><br>\n" if $::debug;
  unless ($ans =~ /DONE/) {
     mailalert("CloseTrustedChannel $id $key failed: $ans");           
  }
  close($heramgr);
  print "Closed trusted channel<br>\n" if $::debug;

  if ($lcount or $rcount) {
    my $count = '';
    $count .= "$lcount local files" if $lcount;
    $count .= " and " if $lcount and $rcount;
    $count .= "$rcount remote files" if $rcount;
    quit("Successful. Saved $count to ".
      "$controlid\'s Hera space.<br>\n".
      "<form action='/cgi-bin/hera/heraclient.pl'>\n".
      "<input type='button' value='Close window' onClick='self.close()'> ".
      "<input type='hidden' name='controlid' value='$controlid'>".
      "<input type='hidden' name='password' value='$password'>".
      "<a href='http://heasarc.gsfc.nasa.gov/docs/software/hera.html'>Intro ".
      "to Hera</a>\n</form>");
  } else {
    quit("Error: No files saved.<br>\n Mail has been sent to the ".
         "maintainers.<br>\n");
  }

} # end sub close_channel

sub quit {
  my ($msg,$filelist,$controlid,$password,$newuser) = @_;
  print "<p><font color=red>$msg</font></p>\n";
  printform($filelist,$controlid,$password,$newuser) if $filelist =~ /\w/; 
  print "quit<br>\n" if $::debug;
  #Browse::Decor::Footer();
  Browse::Decor::EmailFooter();
  Browse::Decor::EndTags();

  exit;
}

sub mailalert {

  # send alert to me and Pan
  #my $addresses = 'cwh@lheamail.gsfc.nasa.gov,chai@lheamail.gsfc.nasa.gov';
  my $addresses = 'lmm@milkyway.gsfc.nasa.gov';

  $ENV{PATH} = "/usr/lib/";
  open(MAIL,"|/usr/lib/sendmail -oi -t");

    print MAIL <<EOT;
To: $addresses
From: Browse-Hera-interface
Reply-To: $addresses
Subject: HeraBrowser error

@_
EOT
    close(MAIL);
}

1;
