#!/usr1/local/bin/perl5 -T
# $Id: remotetar.pl,v 1.2 2002/10/28 17:26:08 cwh Exp $
# See the end of this file for cvs logs.
$::debug=0;

use strict;
use lib './lib';
use Browse::Config;
use LWP;
use Archive::Tar;

#
# Create a TAR file from remote products.
#

#print "Content-type: text/plain\n\n" if $::debug;
Browse::Config::AlwaysRun();

my @files;
#print "QUERYSTRING: $ENV{QUERY_STRING}<br>\n" if $::debug;
my($input) = Browse::CGI::ReadParse();  # Read and parse the query string
foreach my $file (split("\0",$$input{"File"})) {
    push (@files,$file);
}
#print "files=@files<br>\n" if $::debug;

my $tarFile = $$input{"tar"};
$tarFile =~ s/\.\.\///g;
($tarFile) = $tarFile =~ /([\w\.\-\/]+)/; # untaint
#print "tarFile=$tarFile<br>\n" if $::debug;
my $tar = Archive::Tar->new();
my $ua = new LWP::UserAgent;

# Process each remote product individually

foreach my $file (@files) {
    my $tempfile = $file;
    (my $junk,$tempfile) = split('://',$tempfile) if $tempfile =~ /:\/\//;
    ($tempfile) = $tempfile =~ /(.+)/;  #untaint
    #print "file=$file<br>\n" if $::debug;
    my $request = HTTP::Request->new(GET => $file);
    my $data;
    # append to data until get whole file (Tar.pm wants a whole file)
    my $response = $ua->request($request, sub { $data .= $_[0]; } );
    $tar->add_data($tempfile,$data);

    unless ($response->is_success()) {
        Browse::Utils::Error("Request for $file returned error!");
       exit;
    }
}

$tar->write($tarFile);

__END__

# $Log: remotetar.pl,v $
# Revision 1.2  2002/10/28 17:26:08  cwh
# Now using Archive::Tar so that we don't have to create a temporary file locally
# before creating the tarfile.
# Streaming the LWP retreival.
#
# Revision 1.1  2002/10/25 22:13:50  cwh
# Initial commit.
# This script is designed to grab remote data products and put them in a tarfile
# which then is added to the main tarfile created in a user's dp request.
#
