#!/usr1/local/bin/perl5 -T
# $Id: startfv.pl,v 1.9 2003/05/20 18:45:43 cwh Exp $
# $Log: startfv.pl,v $
# Revision 1.9  2003/05/20 18:45:43  cwh
# Needed extra blank line to finish header when file isn't compressed.
#
# Revision 1.8  2003/03/24 21:48:23  cwh
# For Ed, instead of using '^/FTP' as local flag, now using '^/'.
#
# Revision 1.7  2002/12/16 20:28:36  cwh
# Added content-encoding header.
# Added recognition of files zipped with unix 'compress'.
#
# Revision 1.6  2002/10/25 21:59:06  cwh
# Tom's changes to stream files.
#
# Revision 1.5  2002/09/25 19:16:09  cwh
# Added ':' as a valid character.
# Made changes to LWP stuff to handle ftp.
#
# Revision 1.4  2002/02/14 21:42:03  cwh
# Added header to specify a name for the FITS file.
#
# Revision 1.3  2001/12/18 16:27:38  cwh
# Changed do's to use's.
# Added a taint check to the filename from the url string. Also removing any
# '../'s.
#
# Revision 1.2  2001/02/15 21:13:04  cwh
# Made changes so that startfv.pl would work with mod_perl.
#
# Revision 1.1  2000/12/04 20:37:49  cwh
# This script should be called with the url of an image that is to be fed to fv.
# If the user has set up a mime-type handler (ie on Netscape: Edit->Preferences
#  ->Navigator->Applications) for type image/x-fits, calling this script
# should start fv (or another FITS viewer) with the image loaded up.
#
#=========================================================================#
# High Energy Astrophysics Science Archive Research Center (HEASARC),
# NASA/Goddard Space Flight Center, Greenbelt, MD 20771, USA.
#
# You are free to use this code as you wish, but unless you change
# it significantly, please leave the above name and address intact.
#=========================================================================#
# Module Name:    startfv.pl
# Module Author:  Christina Heikkila, Raytheon ITSS
# Date:           October, 2000
# Project:        Browse : HEASARC
#=========================================================================#
# Module Description:
# This script should be called with the url of an image that is to be fed to fv.
# If the user has set up a mime-type handler (ie on Netscape: Edit->Preferences
#  ->Navigator->Applications) for type image/x-fits, calling this script
# should start fv (or another FITS viewer) with the image loaded up.
#=========================================================================#

use strict;
use CGI;
use lib "/www/htdocs/cgi-bin/lib";
use URI;
use LWP;
use HTTP::Headers;
use HTTP::Request;

my $query = new CGI;
$query->import_names();

# need to taint-check since url/file can be specified by user
# check to make sure that only valid chars are used,
# and check the format of the url or filename

$Q::file =~ /([-+\.\/\w:]*)/; 
my $file = $1;
$file =~ s/\.\.\///g;

my ($basename,undef) = split('\/',reverse($file),2); 
print "Content-Disposition: attachment; filename=".reverse($basename)."\n";

if ($file =~ /^\//i) { # local files will start with /

    print "Content-type: image/x-fits\n\n";

    local *FILE;
    my $data="";
    open (FILE, $file);
       while (read(FILE,$data,1024)) {
          print $data;
       }
    close(FILE);

} else { # doesn't start with /, so not a local file

    my $ua = new LWP::UserAgent;
    my $request = HTTP::Request->new(GET => $file);
    $request->header(Accept => 'image/*');
    my $chk;
    my $response = $ua->request($request,
       sub {
             if (!$chk) {
                 $chk = substr($_[0], 0, 2);

                 my $chk1 = ord($chk);
                 my $chk2 = ord(substr($chk,1));

                 # Check if either beginning of SIMPLE= or gzip or compress
                 # magic numbers

                 if ($chk eq "SI"  || ($chk1 == 31 && ($chk2 == 139 || $chk2 ==30 || $chk2 == 157))) {
                     print "Content-type: image/x-fits\n";
                     print "Content-Encoding: x-gzip\n\n" if $chk2 == 139;
                     print "Content-Encoding: x-gzip\n\n" if $chk2 == 30;
                     print "Content-Encoding: x-compress\n\n" if $chk2 == 157;
                     print "\n" unless $chk2 =~ /139|30|157/;
                 } else {
                     print "Content-type: text/plain\n\n";
                 }
             }

             print $_[0];

        }
    );

} #end if file is local or not
