#!/usr1/local/bin/perl5 -T 
# $Id: w3browse_uploads.pl,v 1.4 2004/02/23 16:07:19 lmm Exp $
#=========================================================================#
# High Energy Astrophysics Science Archive Research Center (HEASARC),
# NASA/Goddard Space Flight Center, Greenbelt, MD 20771, USA.
#
# You are free to use this code as you wish, but unless you change
# it significantly, please leave the above name and address intact.
#=========================================================================#
# Module Name:    w3browse_uploads.pl
# Module Author:  Laura McDonald, SSAI
# Date:           November, 2003
# Project:        Browse : HEASARC
#=========================================================================#
# Module Description:
#    Sets up user interface for query and session uploads
#=========================================================================#
#$::debug=1;
use strict;
use lib './lib/';

use Browse::Config;

$0 = 'w3browse_uploads.pl'; #Required for MailMessage - do not remove

#------------------------------------------------------------------------

print Browse::CGI::Header(),"w3browse up: DEBUG MODE<br>\n" if $::debug;

Browse::Config::AlwaysRun();
Browse::Decor::Header("Stored Queries",1,2,0); 

$ENV{PATH} = "/bin/";
my $formname="w3browse";
print "Other Browse interfaces: <a href='$::w3bdocs/w3batchinfo.html'>" .
	"Batch</a> | <a href='w3fullcross.pl'>Correlation</a> | " .
	"<a href='w3catindex.pl'>Index of all tables</a> |" .
	"<a href='w3browse.pl'>Main Search Form</a> ";
        



#--- upload query previously saved to file
print <<UPLOAD;
<p><p>Use this page if you have selected the Save Query To File button after
displaying query results from the <a href='w3browse.pl'>Main Search Form</a>.
<br>
<a target="helpwin" href="$::w3bhelp#Stored_Query_Search">More information</a>
 is available.

<p><form method="POST" enctype='multipart/form-data' name="test" 
   action="uploadQuery.pl">
<br><p>
<label for="user_entry_file"><b>
<a target="helpwin" href="$::w3bhelp#Stored_Query_Search">Submit Previously Saved Query: </a></b>
</label><input type="file" name=upfile  id="user_entry_file"><br>
<input type="submit" name="Action" value="Load Query">
UPLOAD

my $navtrail = "&lt;a class='navpast' href='".$ENV{SCRIPT_NAME}.'?'.$ENV{QUERY_STRING}."' &gt; Main Search Form&lt;/a&gt;";
print "<input type='hidden' name='navtrail' value=\"$navtrail\">\n";
print "<input type='hidden' name='popupForm' value='Query Results'>\n";

print "</form>\n";
print "<br><br><br><b>Saved session query capabilities will be provided on this page in a future release</b>";
Browse::Decor::EmailFooter();

# $Log: w3browse_uploads.pl,v $
# Revision 1.4  2004/02/23 16:07:19  lmm
# Added additional documentation
#
# Revision 1.3  2003/12/04 16:36:08  lmm
# Sets up user interface for query and session uploads
#
