#!/usr1/local/bin/perl5 -T
#
# $Id: w3fullcross.pl,v 1.19 2006/02/22 21:26:57 lmm Exp $
# $Log: w3fullcross.pl,v $
# Revision 1.19  2006/02/22 21:26:57  lmm
# Updated the Other Interfaces list.
#
# Revision 1.18  2003/08/28 20:24:33  lmm
# Set flag to display HEASARC banner
#
# Revision 1.17  2002/09/13 21:09:11  cwh
# Added a name for the form for javascript.
# Added javascript functions for table selection interface.
#
# Revision 1.16  2001/11/08 19:57:40  cwh
# Changed 'do w3config.pl' to 'use Config' and AlwaysRun().
# Added Browse:: to all sub calls.
#
# Revision 1.15  2001/09/15 02:44:38  cwh
# Changed labels for Cornerstone style forms, passing in a question number to
#    Cross::CrossChoices().
#
# Revision 1.14  2001/07/01 02:03:26  cwh
# Got rid of commented-out stuff, removed HEASARC-specific URL.
#
# Revision 1.13  2001/05/24 16:40:44  cwh
# This mod_perl stuff is killing me.  Got rid of all the BEGIN blocks (those aren't
# called if they've been already done once).  Added the 'use lib "./lib";'s back in.
#
# Revision 1.12  2001/05/17 02:15:35  tam
# Changed tables CGI names for cross-correlating
# tables from Table and XTable to Table1 and Table2 to
# de-emphasize distinction between tables.
#
# Revision 1.11  2001/05/03 19:13:32  cwh
# Put call to w3config.pl in a BEGIN statement, pulled all 'use lib's out.
#
# Revision 1.10  2001/04/03 15:57:52  cwh
# Added taint flag.
#
# Revision 1.9  2001/03/12 18:08:02  cwh
# Got rid of Basic interface link.
#
# Revision 1.8  2001/01/22 20:29:48  cwh
# Added links to other Browse interfaces, added navtrail, and rearranged the
# order of form elements - the tables come before the options.
#
# Revision 1.7  2000/03/08 19:57:58  saima
# W3Browse to Browse name change. Added comments to highlight
#   cross-correlation of results.
#
# Revision 1.6  1999/09/29 19:21:14  saima
# Fixed perl5 path on top.
#
# Revision 1.5  1999/05/27 15:37:56  tam
# Modified for Apache mod_perl module.
#   New functionality: Anticorrelations, split line queries, minimal
#   column selection.
#   Options formatting put in Cross.pm
#
# Revision 1.4  1998/12/21 19:46:01  saima
# Modified so that new modules are included using 'use' syntax. Also,
#   added new W3Browse header. Made use of the new
#   Options::TimeSelection() and Options::ResultLimit() to display options.
#
# Revision 1.3  1998/08/03 22:00:11  saima
# Replaced the form name 'target' with 'Target'. The name 'target' gives
#   problems with JavaScript on Netscape 2.
#
# Revision 1.2  1998/07/15 18:58:21  saima
# Added changes so that users can choose if they want to display the
#   results as text only.
#
# Revision 1.1  1998/05/07 20:36:36  saima
# Initial Revision.
#
#=========================================================================#
# High Energy Astrophysics Science Archive Research Center (HEASARC),
# NASA's Goddard Space Flight Center, Greenbelt, MD 20771, USA.
#
# You are free to use this code as you wish, but unless you change
# it significantly, please leave the above name & address intact.
#=========================================================================#
# Module Name:    w3fullcross.pl
# Module Author:  Saima Zobair, Raytheon STX
# Date:           April 1998
# Project:        Browse : HEASARC
#-------------------------------------------------------------------------#
# Module Description:
# 
# The routines in this module allow cross-correlation of full tables.
# Cross correlations can be on time and/or a certain radius.
#
#=========================================================================#

use strict;

use lib './lib';


use Browse::Config;
use Browse::Options;
use Browse::Cross;

Browse::Config::AlwaysRun();

#--------------------------------------------------------------------------

$0 = 'w3fullcross.pl';        # required for MailMessage

#$::debug=1;
#Browse::Decor::Header('Cross-Correlation of Entire Catalogs');
Browse::Decor::Header('Cross-Correlation of Entire Catalogs',0,0,1); # include 
                                                                     # banner

print "<form method=GET name='fullcross' action=\"w3cross.pl\">\n"; 
#print "<script TYPE='text/javascript' LANGUAGE='JavaScript'>reshowTable1(document.fullcross.missionTable1,document.fullcross.Table1);reshowTable2(document.fullcross.missionTable2,document.fullcross.Table2);</script>\n";
print "Other Browse interfaces: <a href=w3browse.pl>Main</a> | " .
   "<a href=w3catindex.pl>Index of all tables</a> | " .
   "<a href=$::w3bdocs/w3batchinfo.html>Batch</a> | " .
   "<a href='$::w3bdocs/browse.html'>" .
   "Keyword Search</a> <font color='red'> New!</font><p>\n";

my $navtrail = "<span class=navcurrent>Choose Cross-Correlation Tables</span> <span class=navfuture>&gt; Search Results &gt; Choose Data Products</span>";
print "$navtrail<p>\n";
$navtrail = " &lt;a class=navpast href=".$ENV{SCRIPT_NAME}."&gt; Choose Cross-Correlation Tables &lt;/a &gt; ";
print "<input type=hidden name=navtrail value=\"$navtrail\">";

print "<p><b>Note:</b> This page allows you to cross-correlate full ",
      "tables. You may also cross-correlate on query results by ",
      "querying the database from the <a href=w3browse.pl>Main Interface</a> and then ",
      "selecting the cross-correlations option after the table of results.\n",
      "<p>";
DisplayCatalogs();
print "<input type=hidden name=fullcross value=1><p>";
Browse::Cross::CrossChoices(1,1,3);  # Both spatial and time correlations...
  
print "</form>\n";
Browse::Cross::Explain();
Browse::Decor::Footer();


#--------------------------------------------------------------------------
sub DisplayCatalogs{

  #$::debug=1;
  # Get the list of tables.
  my($tables) = Browse::HDB::GetCrossTables();

print qq|
<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript"><!--
function reshowTable1(object,table) {
    missionTable1 = object.options[object.selectedIndex].text;
    for (var i = table.length;i > 0;i--)
        table.options[0] = null;
    reloading = true;
    showlinksTable1(table);
    table.options[0].selected = true;
    return false;
}

function reshowTable2(object,table) {
    missionTable2 = object.options[object.selectedIndex].text;
    for (var i = table.length;i > 0;i--)
        table.options[0] = null;
    reloading = true;
    showlinksTable2(table);
    table.options[0].selected = true;
    return false;
}

function opt(href,text,table) {
    if (reloading)  {
        var optionName = new Option(text, href, false, false)
        var length = table.length;
        table.options[length] = optionName;
    }
    else
        document.write('<OPTION VALUE="',href,'">',text,'<\/OPTION>');

}

//--></SCRIPT>

|;
  print Browse::Options::SelectTable('table_list' => $tables,
                             'prompt' => '1. Choose a table:',
                             'CGI_name' => 'Table1',
                             'multiple' => 0,
                             'no_radius' => 0,
                             'code' => 1,
                             'hint' => 0,
                             'size' => 5);

  print "<P>\n";
  print Browse::Options::SelectTable('table_list' => $tables,
                             'prompt' => '2. Choose another table to cross-correlate against the first:',
                             'CGI_name' => 'Table2',
                             'multiple' => 0,
                             'no_radius' => 0,
                             'code' => 1,
                             'hint' => 0,
                             'size' => 5);


} #eosub--DisplayCatalogs
#--------------------------------------------------------------------------
1;
#########
#  EOF  #
#########


