#!/usr1/local/bin/perl5 -T
# $Id: w3server.pl,v 1.11 2003/08/28 20:40:47 lmm Exp $
# $Log: w3server.pl,v $
# Revision 1.11  2003/08/28 20:40:47  lmm
# Removed HEASARC footer
#
# Revision 1.10  2003/07/31 18:48:54  cwh
# Added new call to displayer->legend(), which is broken out of tableHeader,
#   since not all display modes will want to display the legend.
#
# Revision 1.9  2001/11/08 19:57:41  cwh
# Changed 'do w3config.pl' to 'use Config' and AlwaysRun().
# Added Browse:: to all sub calls.
#
# Revision 1.8  2001/07/17 18:54:57  cwh
# Ignore the comment about class in the prev log entry.  Mistakenly committed the
# wrong file.  The only difference being checked in was the addition of the -T
# taint flag.
#
# Revision 1.7  2001/07/17 18:51:26  cwh
# Changed 'next if /class/' to 'next if /^class$/' - parameters with class in
#   their name were being suppressed, i.e. 'iue_class'.  Meant to only
#   suppress 'class'.
#
# Revision 1.6  2001/05/24 16:40:45  cwh
# This mod_perl stuff is killing me.  Got rid of all the BEGIN blocks (those aren't
# called if they've been already done once).  Added the 'use lib "./lib";'s back in.
#
# Revision 1.5  2001/05/22 17:57:12  cwh
# Added Id, Log to those scripts that needed it.
#

use strict;
use lib './lib';

use Browse::Config;
use Browse::QueryRequest;
use Browse::Display;

$| = 1;
Browse::Config::AlwaysRun();

my $in = Browse::CGI::ReadParse();

my $requestString = $$in{request};
my ($req)  = Browse::QueryRequest::deserialize($requestString);

if ($$in{fields}) {
    my $flds = $$in{fields};
    if (!ref($flds) && $flds =~ /^all$/i) {
        $req->setFields($flds);
    } else {
        my @fields = split("\0", $$in{fields});
        $req->setFields(\@fields);
    }
}

# Get all the rows for this query.
$req->setMaxRows(0);

my $mode = $$in{dispmode};
 
my $disp = Browse::Display->new($mode);

$disp->pageHeader();

my $nrow;
my $block;

while ($block = $req->getResult()) {
    if ($$block{"type"} eq "meta") {
        if ($nrow > 0) {
	    last;
	}
        $disp->processMeta($block);
    } elsif ($$block{"type"} eq "data") {
        if ($nrow == 0) {
	    $disp->tableHeader();
	    $disp->legend();
	}
	$disp->processData($block);
        $nrow += 1;
    } else {
        last;
    }
}

$disp->tableFooter();
#$disp->pageFooter();

