/***************************************************************************
/*  ned_client.h      Xiuqin Wu  Nov. 9, 1993
/*
/***************************************************************************/

/* definition of error codes NE_  */
#define NE_NAME             1  /* obj name not recognized by NED name
				  interpreter EGRET */ 
#define NE_AMBN             2  /* ambiguous input name */
#define NE_RA               3  /* RA is  out [0.0, 360.0] */
#define NE_DEC              4  /* DEC is out [-90.0, 90.0] */
#define NE_RADIUS           5  /* radius is out (0.0, 300] */
#define NE_JB               6  /* equinox starts with J or B */
#define NE_EPOCH            7  /*  epoch is out [1500.0, 2500.0] */
#define NE_IAU              8  /* unacceptible IAU format  */
#define NE_NOBJ             9  /* no object found */
#define NE_NOSPACE          10  /* memory allocation failure */
#define NE_QUERY            11 /* can't send query to server, 
				  connection problem */
#define NE_HOST             12  /* can't get hostent from the name */
#define NE_SERVICE          13  /* can't get the port number for the service */
#define NE_PROTO            14  /* can't conver tcp to protocol number */
#define NE_SOCK             15  /* can't get a socket allocated */
#define NE_CONNECT          16  /* can't connect to server */
#define NE_BROKENC          17  /* the connection is broken */
#define NE_TBLSIZE          18  /* can't get table size */

typedef struct _crossid {
   char  objname[31];
   char  objtype[7];
   } CrossID;


typedef struct _more_data {
   char       data_typec[61];   /* data type code to describe the data */
   char       data[101];
   struct _more_data *next;
   } MoreData;


typedef struct _obj_info {
   int        no_crossid;  /* number of crossids for the object */
   CrossID   *cp;
   double     dist;        /* distance to the search center */
   int        no_ref;      /* number of references */
   int        no_note;     /* number of notes */
   int        no_photom;   /* number of photometric data points */
   char       objtype[7];
   double     ra;          /* J2000 */
   double     dec;
   double     unc_maj;
   double     unc_min;
   double     unc_ang;
   char       refcode[20];
   MoreData   *mdp;
   } ObjInfo;

